diff -urNp linux-2.6.32.24/drivers/scsi/libfc/fc_exch.c linux-2.6.32.24/drivers/scsi/libfc/fc_exch.c
--- linux-2.6.32.24/drivers/scsi/libfc/fc_exch.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/scsi/libfc/fc_exch.c	2010-09-04 15:54:52.000000000 -0400
@@ -86,12 +86,12 @@ struct fc_exch_mgr {
 	 * all together if not used XXX
 	 */
 	struct {
-		atomic_t no_free_exch;
-		atomic_t no_free_exch_xid;
-		atomic_t xid_not_found;
-		atomic_t xid_busy;
-		atomic_t seq_not_found;
-		atomic_t non_bls_resp;
+		atomic_unchecked_t no_free_exch;
+		atomic_unchecked_t no_free_exch_xid;
+		atomic_unchecked_t xid_not_found;
+		atomic_unchecked_t xid_busy;
+		atomic_unchecked_t seq_not_found;
+		atomic_unchecked_t non_bls_resp;
 	} stats;
 };
 #define	fc_seq_exch(sp) container_of(sp, struct fc_exch, seq)
@@ -510,7 +510,7 @@ static struct fc_exch *fc_exch_em_alloc(
 	/* allocate memory for exchange */
 	ep = mempool_alloc(mp->ep_pool, GFP_ATOMIC);
 	if (!ep) {
-		atomic_inc(&mp->stats.no_free_exch);
+		atomic_inc_unchecked(&mp->stats.no_free_exch);
 		goto out;
 	}
 	memset(ep, 0, sizeof(*ep));
@@ -557,7 +557,7 @@ out:
 	return ep;
 err:
 	spin_unlock_bh(&pool->lock);
-	atomic_inc(&mp->stats.no_free_exch_xid);
+	atomic_inc_unchecked(&mp->stats.no_free_exch_xid);
 	mempool_free(ep, mp->ep_pool);
 	return NULL;
 }
@@ -690,7 +690,7 @@ static enum fc_pf_rjt_reason fc_seq_look
 		xid = ntohs(fh->fh_ox_id);	/* we originated exch */
 		ep = fc_exch_find(mp, xid);
 		if (!ep) {
-			atomic_inc(&mp->stats.xid_not_found);
+			atomic_inc_unchecked(&mp->stats.xid_not_found);
 			reject = FC_RJT_OX_ID;
 			goto out;
 		}
@@ -720,7 +720,7 @@ static enum fc_pf_rjt_reason fc_seq_look
 		ep = fc_exch_find(mp, xid);
 		if ((f_ctl & FC_FC_FIRST_SEQ) && fc_sof_is_init(fr_sof(fp))) {
 			if (ep) {
-				atomic_inc(&mp->stats.xid_busy);
+				atomic_inc_unchecked(&mp->stats.xid_busy);
 				reject = FC_RJT_RX_ID;
 				goto rel;
 			}
@@ -731,7 +731,7 @@ static enum fc_pf_rjt_reason fc_seq_look
 			}
 			xid = ep->xid;	/* get our XID */
 		} else if (!ep) {
-			atomic_inc(&mp->stats.xid_not_found);
+			atomic_inc_unchecked(&mp->stats.xid_not_found);
 			reject = FC_RJT_RX_ID;	/* XID not found */
 			goto out;
 		}
@@ -752,7 +752,7 @@ static enum fc_pf_rjt_reason fc_seq_look
 	} else {
 		sp = &ep->seq;
 		if (sp->id != fh->fh_seq_id) {
-			atomic_inc(&mp->stats.seq_not_found);
+			atomic_inc_unchecked(&mp->stats.seq_not_found);
 			reject = FC_RJT_SEQ_ID;	/* sequence/exch should exist */
 			goto rel;
 		}
@@ -1163,22 +1163,22 @@ static void fc_exch_recv_seq_resp(struct
 
 	ep = fc_exch_find(mp, ntohs(fh->fh_ox_id));
 	if (!ep) {
-		atomic_inc(&mp->stats.xid_not_found);
+		atomic_inc_unchecked(&mp->stats.xid_not_found);
 		goto out;
 	}
 	if (ep->esb_stat & ESB_ST_COMPLETE) {
-		atomic_inc(&mp->stats.xid_not_found);
+		atomic_inc_unchecked(&mp->stats.xid_not_found);
 		goto out;
 	}
 	if (ep->rxid == FC_XID_UNKNOWN)
 		ep->rxid = ntohs(fh->fh_rx_id);
 	if (ep->sid != 0 && ep->sid != ntoh24(fh->fh_d_id)) {
-		atomic_inc(&mp->stats.xid_not_found);
+		atomic_inc_unchecked(&mp->stats.xid_not_found);
 		goto rel;
 	}
 	if (ep->did != ntoh24(fh->fh_s_id) &&
 	    ep->did != FC_FID_FLOGI) {
-		atomic_inc(&mp->stats.xid_not_found);
+		atomic_inc_unchecked(&mp->stats.xid_not_found);
 		goto rel;
 	}
 	sof = fr_sof(fp);
@@ -1189,7 +1189,7 @@ static void fc_exch_recv_seq_resp(struct
 	} else {
 		sp = &ep->seq;
 		if (sp->id != fh->fh_seq_id) {
-			atomic_inc(&mp->stats.seq_not_found);
+			atomic_inc_unchecked(&mp->stats.seq_not_found);
 			goto rel;
 		}
 	}
@@ -1249,9 +1249,9 @@ static void fc_exch_recv_resp(struct fc_
 	sp = fc_seq_lookup_orig(mp, fp);	/* doesn't hold sequence */
 
 	if (!sp)
-		atomic_inc(&mp->stats.xid_not_found);
+		atomic_inc_unchecked(&mp->stats.xid_not_found);
 	else
-		atomic_inc(&mp->stats.non_bls_resp);
+		atomic_inc_unchecked(&mp->stats.non_bls_resp);
 
 	fc_frame_free(fp);
 }
diff -urNp linux-2.6.32.24/drivers/scsi/libsas/sas_ata.c linux-2.6.32.24/drivers/scsi/libsas/sas_ata.c
--- linux-2.6.32.24/drivers/scsi/libsas/sas_ata.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/scsi/libsas/sas_ata.c	2010-09-04 15:54:52.000000000 -0400
@@ -343,7 +343,7 @@ static int sas_ata_scr_read(struct ata_l
 	}
 }
 
-static struct ata_port_operations sas_sata_ops = {
+static const struct ata_port_operations sas_sata_ops = {
 	.phy_reset		= sas_ata_phy_reset,
 	.post_internal_cmd	= sas_ata_post_internal,
 	.qc_prep		= ata_noop_qc_prep,
diff -urNp linux-2.6.32.24/drivers/scsi/mpt2sas/mpt2sas_debug.h linux-2.6.32.24/drivers/scsi/mpt2sas/mpt2sas_debug.h
--- linux-2.6.32.24/drivers/scsi/mpt2sas/mpt2sas_debug.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/scsi/mpt2sas/mpt2sas_debug.h	2010-09-04 15:54:52.000000000 -0400
@@ -79,7 +79,7 @@
 		CMD;						\
 }
 #else
-#define MPT_CHECK_LOGGING(IOC, CMD, BITS)
+#define MPT_CHECK_LOGGING(IOC, CMD, BITS) do {} while (0)
 #endif /* CONFIG_SCSI_MPT2SAS_LOGGING */
 
 
diff -urNp linux-2.6.32.24/drivers/scsi/scsi_logging.h linux-2.6.32.24/drivers/scsi/scsi_logging.h
--- linux-2.6.32.24/drivers/scsi/scsi_logging.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/scsi/scsi_logging.h	2010-09-04 15:54:52.000000000 -0400
@@ -51,7 +51,7 @@ do {								\
 		} while (0);					\
 } while (0)
 #else
-#define SCSI_CHECK_LOGGING(SHIFT, BITS, LEVEL, CMD)
+#define SCSI_CHECK_LOGGING(SHIFT, BITS, LEVEL, CMD) do {} while (0)
 #endif /* CONFIG_SCSI_LOGGING */
 
 /*
diff -urNp linux-2.6.32.24/drivers/scsi/sg.c linux-2.6.32.24/drivers/scsi/sg.c
--- linux-2.6.32.24/drivers/scsi/sg.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/scsi/sg.c	2010-09-04 15:54:52.000000000 -0400
@@ -2292,7 +2292,7 @@ struct sg_proc_leaf {
 	const struct file_operations * fops;
 };
 
-static struct sg_proc_leaf sg_proc_leaf_arr[] = {
+static const struct sg_proc_leaf sg_proc_leaf_arr[] = {
 	{"allow_dio", &adio_fops},
 	{"debug", &debug_fops},
 	{"def_reserved_size", &dressz_fops},
@@ -2307,7 +2307,7 @@ sg_proc_init(void)
 {
 	int k, mask;
 	int num_leaves = ARRAY_SIZE(sg_proc_leaf_arr);
-	struct sg_proc_leaf * leaf;
+	const struct sg_proc_leaf * leaf;
 
 	sg_proc_sgp = proc_mkdir(sg_proc_sg_dirname, NULL);
 	if (!sg_proc_sgp)
diff -urNp linux-2.6.32.24/drivers/serial/8250_pci.c linux-2.6.32.24/drivers/serial/8250_pci.c
--- linux-2.6.32.24/drivers/serial/8250_pci.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/serial/8250_pci.c	2010-09-04 15:54:52.000000000 -0400
@@ -3664,7 +3664,7 @@ static struct pci_device_id serial_pci_t
 		PCI_ANY_ID, PCI_ANY_ID,
 		PCI_CLASS_COMMUNICATION_MULTISERIAL << 8,
 		0xffff00, pbn_default },
-	{ 0, }
+	{ 0, 0, 0, 0, 0, 0, 0 }
 };
 
 static struct pci_driver serial_pci_driver = {
diff -urNp linux-2.6.32.24/drivers/serial/kgdboc.c linux-2.6.32.24/drivers/serial/kgdboc.c
--- linux-2.6.32.24/drivers/serial/kgdboc.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/serial/kgdboc.c	2010-09-04 15:54:52.000000000 -0400
@@ -18,7 +18,7 @@
 
 #define MAX_CONFIG_LEN		40
 
-static struct kgdb_io		kgdboc_io_ops;
+static const struct kgdb_io	kgdboc_io_ops;
 
 /* -1 = init not run yet, 0 = unconfigured, 1 = configured. */
 static int configured		= -1;
@@ -154,7 +154,7 @@ static void kgdboc_post_exp_handler(void
 		module_put(THIS_MODULE);
 }
 
-static struct kgdb_io kgdboc_io_ops = {
+static const struct kgdb_io kgdboc_io_ops = {
 	.name			= "kgdboc",
 	.read_char		= kgdboc_get_char,
 	.write_char		= kgdboc_put_char,
diff -urNp linux-2.6.32.24/drivers/staging/android/binder.c linux-2.6.32.24/drivers/staging/android/binder.c
--- linux-2.6.32.24/drivers/staging/android/binder.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/android/binder.c	2010-09-04 15:54:52.000000000 -0400
@@ -2756,7 +2756,7 @@ static void binder_vma_close(struct vm_a
 	binder_defer_work(proc, BINDER_DEFERRED_PUT_FILES);
 }
 
-static struct vm_operations_struct binder_vm_ops = {
+static const struct vm_operations_struct binder_vm_ops = {
 	.open = binder_vma_open,
 	.close = binder_vma_close,
 };
diff -urNp linux-2.6.32.24/drivers/staging/b3dfg/b3dfg.c linux-2.6.32.24/drivers/staging/b3dfg/b3dfg.c
--- linux-2.6.32.24/drivers/staging/b3dfg/b3dfg.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/b3dfg/b3dfg.c	2010-09-04 15:54:52.000000000 -0400
@@ -455,7 +455,7 @@ static int b3dfg_vma_fault(struct vm_are
 	return VM_FAULT_NOPAGE;
 }
 
-static struct vm_operations_struct b3dfg_vm_ops = {
+static const struct vm_operations_struct b3dfg_vm_ops = {
 	.fault = b3dfg_vma_fault,
 };
 
@@ -848,7 +848,7 @@ static int b3dfg_mmap(struct file *filp,
 	return r;
 }
 
-static struct file_operations b3dfg_fops = {
+static const struct file_operations b3dfg_fops = {
 	.owner = THIS_MODULE,
 	.open = b3dfg_open,
 	.release = b3dfg_release,
diff -urNp linux-2.6.32.24/drivers/staging/comedi/comedi_fops.c linux-2.6.32.24/drivers/staging/comedi/comedi_fops.c
--- linux-2.6.32.24/drivers/staging/comedi/comedi_fops.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/comedi/comedi_fops.c	2010-09-04 15:54:52.000000000 -0400
@@ -1389,7 +1389,7 @@ void comedi_unmap(struct vm_area_struct 
 	mutex_unlock(&dev->mutex);
 }
 
-static struct vm_operations_struct comedi_vm_ops = {
+static const struct vm_operations_struct comedi_vm_ops = {
 	.close = comedi_unmap,
 };
 
diff -urNp linux-2.6.32.24/drivers/staging/dream/qdsp5/adsp_driver.c linux-2.6.32.24/drivers/staging/dream/qdsp5/adsp_driver.c
--- linux-2.6.32.24/drivers/staging/dream/qdsp5/adsp_driver.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/dream/qdsp5/adsp_driver.c	2010-09-04 15:54:52.000000000 -0400
@@ -576,7 +576,7 @@ static struct adsp_device *inode_to_devi
 static dev_t adsp_devno;
 static struct class *adsp_class;
 
-static struct file_operations adsp_fops = {
+static const struct file_operations adsp_fops = {
 	.owner = THIS_MODULE,
 	.open = adsp_open,
 	.unlocked_ioctl = adsp_ioctl,
diff -urNp linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_aac.c linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_aac.c
--- linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_aac.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_aac.c	2010-09-04 15:54:52.000000000 -0400
@@ -1022,7 +1022,7 @@ done:
 	return rc;
 }
 
-static struct file_operations audio_aac_fops = {
+static const struct file_operations audio_aac_fops = {
 	.owner = THIS_MODULE,
 	.open = audio_open,
 	.release = audio_release,
diff -urNp linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_amrnb.c linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_amrnb.c
--- linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_amrnb.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_amrnb.c	2010-09-04 15:54:52.000000000 -0400
@@ -833,7 +833,7 @@ done:
 	return rc;
 }
 
-static struct file_operations audio_amrnb_fops = {
+static const struct file_operations audio_amrnb_fops = {
 	.owner = THIS_MODULE,
 	.open = audamrnb_open,
 	.release = audamrnb_release,
diff -urNp linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_evrc.c linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_evrc.c
--- linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_evrc.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_evrc.c	2010-09-04 15:54:52.000000000 -0400
@@ -805,7 +805,7 @@ dma_fail:
 	return rc;
 }
 
-static struct file_operations audio_evrc_fops = {
+static const struct file_operations audio_evrc_fops = {
 	.owner = THIS_MODULE,
 	.open = audevrc_open,
 	.release = audevrc_release,
diff -urNp linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_in.c linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_in.c
--- linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_in.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_in.c	2010-09-04 15:54:52.000000000 -0400
@@ -913,7 +913,7 @@ static int audpre_open(struct inode *ino
 	return 0;
 }
 
-static struct file_operations audio_fops = {
+static const struct file_operations audio_fops = {
 	.owner		= THIS_MODULE,
 	.open		= audio_in_open,
 	.release	= audio_in_release,
@@ -922,7 +922,7 @@ static struct file_operations audio_fops
 	.unlocked_ioctl	= audio_in_ioctl,
 };
 
-static struct file_operations audpre_fops = {
+static const struct file_operations audpre_fops = {
 	.owner          = THIS_MODULE,
 	.open           = audpre_open,
 	.unlocked_ioctl = audpre_ioctl,
diff -urNp linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_mp3.c linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_mp3.c
--- linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_mp3.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_mp3.c	2010-09-04 15:54:52.000000000 -0400
@@ -941,7 +941,7 @@ done:
 	return rc;
 }
 
-static struct file_operations audio_mp3_fops = {
+static const struct file_operations audio_mp3_fops = {
 	.owner		= THIS_MODULE,
 	.open		= audio_open,
 	.release	= audio_release,
diff -urNp linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_out.c linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_out.c
--- linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_out.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_out.c	2010-09-04 15:54:52.000000000 -0400
@@ -810,7 +810,7 @@ static int audpp_open(struct inode *inod
 	return 0;
 }
 
-static struct file_operations audio_fops = {
+static const struct file_operations audio_fops = {
 	.owner		= THIS_MODULE,
 	.open		= audio_open,
 	.release	= audio_release,
@@ -819,7 +819,7 @@ static struct file_operations audio_fops
 	.unlocked_ioctl	= audio_ioctl,
 };
 
-static struct file_operations audpp_fops = {
+static const struct file_operations audpp_fops = {
 	.owner		= THIS_MODULE,
 	.open		= audpp_open,
 	.unlocked_ioctl	= audpp_ioctl,
diff -urNp linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_qcelp.c linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_qcelp.c
--- linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_qcelp.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/dream/qdsp5/audio_qcelp.c	2010-09-04 15:54:52.000000000 -0400
@@ -816,7 +816,7 @@ err:
 	return rc;
 }
 
-static struct file_operations audio_qcelp_fops = {
+static const struct file_operations audio_qcelp_fops = {
 	.owner = THIS_MODULE,
 	.open = audqcelp_open,
 	.release = audqcelp_release,
diff -urNp linux-2.6.32.24/drivers/staging/dream/qdsp5/snd.c linux-2.6.32.24/drivers/staging/dream/qdsp5/snd.c
--- linux-2.6.32.24/drivers/staging/dream/qdsp5/snd.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/dream/qdsp5/snd.c	2010-09-04 15:54:52.000000000 -0400
@@ -242,7 +242,7 @@ err:
 	return rc;
 }
 
-static struct file_operations snd_fops = {
+static const struct file_operations snd_fops = {
 	.owner		= THIS_MODULE,
 	.open		= snd_open,
 	.release	= snd_release,
diff -urNp linux-2.6.32.24/drivers/staging/dream/smd/smd_qmi.c linux-2.6.32.24/drivers/staging/dream/smd/smd_qmi.c
--- linux-2.6.32.24/drivers/staging/dream/smd/smd_qmi.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/dream/smd/smd_qmi.c	2010-09-04 15:54:52.000000000 -0400
@@ -793,7 +793,7 @@ static int qmi_release(struct inode *ip,
 	return 0;
 }
 
-static struct file_operations qmi_fops = {
+static const struct file_operations qmi_fops = {
 	.owner = THIS_MODULE,
 	.read = qmi_read,
 	.write = qmi_write,
diff -urNp linux-2.6.32.24/drivers/staging/dream/smd/smd_rpcrouter_device.c linux-2.6.32.24/drivers/staging/dream/smd/smd_rpcrouter_device.c
--- linux-2.6.32.24/drivers/staging/dream/smd/smd_rpcrouter_device.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/dream/smd/smd_rpcrouter_device.c	2010-09-04 15:54:52.000000000 -0400
@@ -214,7 +214,7 @@ static long rpcrouter_ioctl(struct file 
 	return rc;
 }
 
-static struct file_operations rpcrouter_server_fops = {
+static const struct file_operations rpcrouter_server_fops = {
 	.owner	 = THIS_MODULE,
 	.open	 = rpcrouter_open,
 	.release = rpcrouter_release,
@@ -224,7 +224,7 @@ static struct file_operations rpcrouter_
 	.unlocked_ioctl	 = rpcrouter_ioctl,
 };
 
-static struct file_operations rpcrouter_router_fops = {
+static const struct file_operations rpcrouter_router_fops = {
 	.owner	 = THIS_MODULE,
 	.open	 = rpcrouter_open,
 	.release = rpcrouter_release,
diff -urNp linux-2.6.32.24/drivers/staging/dst/dcore.c linux-2.6.32.24/drivers/staging/dst/dcore.c
--- linux-2.6.32.24/drivers/staging/dst/dcore.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/dst/dcore.c	2010-09-04 15:54:52.000000000 -0400
@@ -149,7 +149,7 @@ static int dst_bdev_release(struct gendi
 	return 0;
 }
 
-static struct block_device_operations dst_blk_ops = {
+static const struct block_device_operations dst_blk_ops = {
 	.open		= dst_bdev_open,
 	.release	= dst_bdev_release,
 	.owner		= THIS_MODULE,
@@ -588,7 +588,7 @@ static struct dst_node *dst_alloc_node(s
 	n->size = ctl->size;
 
 	atomic_set(&n->refcnt, 1);
-	atomic_long_set(&n->gen, 0);
+	atomic_long_set_unchecked(&n->gen, 0);
 	snprintf(n->name, sizeof(n->name), "%s", ctl->name);
 
 	err = dst_node_sysfs_init(n);
diff -urNp linux-2.6.32.24/drivers/staging/dst/trans.c linux-2.6.32.24/drivers/staging/dst/trans.c
--- linux-2.6.32.24/drivers/staging/dst/trans.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/dst/trans.c	2010-09-04 15:54:52.000000000 -0400
@@ -169,7 +169,7 @@ int dst_process_bio(struct dst_node *n, 
 	t->error = 0;
 	t->retries = 0;
 	atomic_set(&t->refcnt, 1);
-	t->gen = atomic_long_inc_return(&n->gen);
+	t->gen = atomic_long_inc_return_unchecked(&n->gen);
 
 	t->enc = bio_data_dir(bio);
 	dst_bio_to_cmd(bio, &t->cmd, DST_IO, t->gen);
diff -urNp linux-2.6.32.24/drivers/staging/go7007/go7007-v4l2.c linux-2.6.32.24/drivers/staging/go7007/go7007-v4l2.c
--- linux-2.6.32.24/drivers/staging/go7007/go7007-v4l2.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/go7007/go7007-v4l2.c	2010-09-04 15:54:52.000000000 -0400
@@ -1700,7 +1700,7 @@ static int go7007_vm_fault(struct vm_are
 	return 0;
 }
 
-static struct vm_operations_struct go7007_vm_ops = {
+static const struct vm_operations_struct go7007_vm_ops = {
 	.open	= go7007_vm_open,
 	.close	= go7007_vm_close,
 	.fault	= go7007_vm_fault,
diff -urNp linux-2.6.32.24/drivers/staging/hv/blkvsc_drv.c linux-2.6.32.24/drivers/staging/hv/blkvsc_drv.c
--- linux-2.6.32.24/drivers/staging/hv/blkvsc_drv.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/hv/blkvsc_drv.c	2010-09-04 15:54:52.000000000 -0400
@@ -153,7 +153,7 @@ static int blkvsc_ringbuffer_size = BLKV
 /* The one and only one */
 static struct blkvsc_driver_context g_blkvsc_drv;
 
-static struct block_device_operations block_ops = {
+static const struct block_device_operations block_ops = {
 	.owner = THIS_MODULE,
 	.open = blkvsc_open,
 	.release = blkvsc_release,
diff -urNp linux-2.6.32.24/drivers/staging/hv/Hv.c linux-2.6.32.24/drivers/staging/hv/Hv.c
--- linux-2.6.32.24/drivers/staging/hv/Hv.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/hv/Hv.c	2010-09-04 15:54:52.000000000 -0400
@@ -161,7 +161,7 @@ static u64 HvDoHypercall(u64 Control, vo
 	u64 outputAddress = (Output) ? virt_to_phys(Output) : 0;
 	u32 outputAddressHi = outputAddress >> 32;
 	u32 outputAddressLo = outputAddress & 0xFFFFFFFF;
-	volatile void *hypercallPage = gHvContext.HypercallPage;
+	volatile void *hypercallPage = ktva_ktla(gHvContext.HypercallPage);
 
 	DPRINT_DBG(VMBUS, "Hypercall <control %llx input %p output %p>",
 		   Control, Input, Output);
diff -urNp linux-2.6.32.24/drivers/staging/panel/panel.c linux-2.6.32.24/drivers/staging/panel/panel.c
--- linux-2.6.32.24/drivers/staging/panel/panel.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/panel/panel.c	2010-09-04 15:54:52.000000000 -0400
@@ -1305,7 +1305,7 @@ static int lcd_release(struct inode *ino
 	return 0;
 }
 
-static struct file_operations lcd_fops = {
+static const struct file_operations lcd_fops = {
 	.write   = lcd_write,
 	.open    = lcd_open,
 	.release = lcd_release,
@@ -1565,7 +1565,7 @@ static int keypad_release(struct inode *
 	return 0;
 }
 
-static struct file_operations keypad_fops = {
+static const struct file_operations keypad_fops = {
 	.read    = keypad_read,		/* read */
 	.open    = keypad_open,		/* open */
 	.release = keypad_release,	/* close */
diff -urNp linux-2.6.32.24/drivers/staging/phison/phison.c linux-2.6.32.24/drivers/staging/phison/phison.c
--- linux-2.6.32.24/drivers/staging/phison/phison.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/phison/phison.c	2010-09-04 15:54:52.000000000 -0400
@@ -43,7 +43,7 @@ static struct scsi_host_template phison_
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations phison_ops = {
+static const struct ata_port_operations phison_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.prereset		= phison_pre_reset,
 };
diff -urNp linux-2.6.32.24/drivers/staging/poch/poch.c linux-2.6.32.24/drivers/staging/poch/poch.c
--- linux-2.6.32.24/drivers/staging/poch/poch.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/poch/poch.c	2010-09-04 15:54:52.000000000 -0400
@@ -1057,7 +1057,7 @@ static int poch_ioctl(struct inode *inod
 	return 0;
 }
 
-static struct file_operations poch_fops = {
+static const struct file_operations poch_fops = {
 	.owner = THIS_MODULE,
 	.open = poch_open,
 	.release = poch_release,
diff -urNp linux-2.6.32.24/drivers/staging/pohmelfs/inode.c linux-2.6.32.24/drivers/staging/pohmelfs/inode.c
--- linux-2.6.32.24/drivers/staging/pohmelfs/inode.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/pohmelfs/inode.c	2010-09-04 15:54:52.000000000 -0400
@@ -1850,7 +1850,7 @@ static int pohmelfs_fill_super(struct su
 	mutex_init(&psb->mcache_lock);
 	psb->mcache_root = RB_ROOT;
 	psb->mcache_timeout = msecs_to_jiffies(5000);
-	atomic_long_set(&psb->mcache_gen, 0);
+	atomic_long_set_unchecked(&psb->mcache_gen, 0);
 
 	psb->trans_max_pages = 100;
 
diff -urNp linux-2.6.32.24/drivers/staging/pohmelfs/mcache.c linux-2.6.32.24/drivers/staging/pohmelfs/mcache.c
--- linux-2.6.32.24/drivers/staging/pohmelfs/mcache.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/pohmelfs/mcache.c	2010-09-04 15:54:52.000000000 -0400
@@ -121,7 +121,7 @@ struct pohmelfs_mcache *pohmelfs_mcache_
 	m->data = data;
 	m->start = start;
 	m->size = size;
-	m->gen = atomic_long_inc_return(&psb->mcache_gen);
+	m->gen = atomic_long_inc_return_unchecked(&psb->mcache_gen);
 
 	mutex_lock(&psb->mcache_lock);
 	err = pohmelfs_mcache_insert(psb, m);
diff -urNp linux-2.6.32.24/drivers/staging/pohmelfs/netfs.h linux-2.6.32.24/drivers/staging/pohmelfs/netfs.h
--- linux-2.6.32.24/drivers/staging/pohmelfs/netfs.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/pohmelfs/netfs.h	2010-09-04 15:54:52.000000000 -0400
@@ -570,7 +570,7 @@ struct pohmelfs_config;
 struct pohmelfs_sb {
 	struct rb_root		mcache_root;
 	struct mutex		mcache_lock;
-	atomic_long_t		mcache_gen;
+	atomic_long_unchecked_t	mcache_gen;
 	unsigned long		mcache_timeout;
 
 	unsigned int		idx;
diff -urNp linux-2.6.32.24/drivers/staging/sep/sep_driver.c linux-2.6.32.24/drivers/staging/sep/sep_driver.c
--- linux-2.6.32.24/drivers/staging/sep/sep_driver.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/sep/sep_driver.c	2010-09-04 15:54:52.000000000 -0400
@@ -2603,7 +2603,7 @@ static struct pci_driver sep_pci_driver 
 static dev_t sep_devno;
 
 /* the files operations structure of the driver */
-static struct file_operations sep_file_operations = {
+static const struct file_operations sep_file_operations = {
 	.owner = THIS_MODULE,
 	.ioctl = sep_ioctl,
 	.poll = sep_poll,
diff -urNp linux-2.6.32.24/drivers/staging/vme/devices/vme_user.c linux-2.6.32.24/drivers/staging/vme/devices/vme_user.c
--- linux-2.6.32.24/drivers/staging/vme/devices/vme_user.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/staging/vme/devices/vme_user.c	2010-09-04 15:54:52.000000000 -0400
@@ -136,7 +136,7 @@ static int vme_user_ioctl(struct inode *
 static int __init vme_user_probe(struct device *, int, int);
 static int __exit vme_user_remove(struct device *, int, int);
 
-static struct file_operations vme_user_fops = {
+static const struct file_operations vme_user_fops = {
         .open = vme_user_open,
         .release = vme_user_release,
         .read = vme_user_read,
diff -urNp linux-2.6.32.24/drivers/uio/uio.c linux-2.6.32.24/drivers/uio/uio.c
--- linux-2.6.32.24/drivers/uio/uio.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/uio/uio.c	2010-09-04 15:54:52.000000000 -0400
@@ -129,7 +129,7 @@ static ssize_t map_type_show(struct kobj
 	return entry->show(mem, buf);
 }
 
-static struct sysfs_ops map_sysfs_ops = {
+static const struct sysfs_ops map_sysfs_ops = {
 	.show = map_type_show,
 };
 
@@ -217,7 +217,7 @@ static ssize_t portio_type_show(struct k
 	return entry->show(port, buf);
 }
 
-static struct sysfs_ops portio_sysfs_ops = {
+static const struct sysfs_ops portio_sysfs_ops = {
 	.show = portio_type_show,
 };
 
diff -urNp linux-2.6.32.24/drivers/usb/atm/usbatm.c linux-2.6.32.24/drivers/usb/atm/usbatm.c
--- linux-2.6.32.24/drivers/usb/atm/usbatm.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/usb/atm/usbatm.c	2010-09-04 15:54:52.000000000 -0400
@@ -333,7 +333,7 @@ static void usbatm_extract_one_cell(stru
 		if (printk_ratelimit())
 			atm_warn(instance, "%s: OAM not supported (vpi %d, vci %d)!\n",
 				__func__, vpi, vci);
-		atomic_inc(&vcc->stats->rx_err);
+		atomic_inc_unchecked(&vcc->stats->rx_err);
 		return;
 	}
 
@@ -361,7 +361,7 @@ static void usbatm_extract_one_cell(stru
 		if (length > ATM_MAX_AAL5_PDU) {
 			atm_rldbg(instance, "%s: bogus length %u (vcc: 0x%p)!\n",
 				  __func__, length, vcc);
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 			goto out;
 		}
 
@@ -370,14 +370,14 @@ static void usbatm_extract_one_cell(stru
 		if (sarb->len < pdu_length) {
 			atm_rldbg(instance, "%s: bogus pdu_length %u (sarb->len: %u, vcc: 0x%p)!\n",
 				  __func__, pdu_length, sarb->len, vcc);
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 			goto out;
 		}
 
 		if (crc32_be(~0, skb_tail_pointer(sarb) - pdu_length, pdu_length) != 0xc704dd7b) {
 			atm_rldbg(instance, "%s: packet failed crc check (vcc: 0x%p)!\n",
 				  __func__, vcc);
-			atomic_inc(&vcc->stats->rx_err);
+			atomic_inc_unchecked(&vcc->stats->rx_err);
 			goto out;
 		}
 
@@ -387,7 +387,7 @@ static void usbatm_extract_one_cell(stru
 			if (printk_ratelimit())
 				atm_err(instance, "%s: no memory for skb (length: %u)!\n",
 					__func__, length);
-			atomic_inc(&vcc->stats->rx_drop);
+			atomic_inc_unchecked(&vcc->stats->rx_drop);
 			goto out;
 		}
 
@@ -412,7 +412,7 @@ static void usbatm_extract_one_cell(stru
 
 		vcc->push(vcc, skb);
 
-		atomic_inc(&vcc->stats->rx);
+		atomic_inc_unchecked(&vcc->stats->rx);
 	out:
 		skb_trim(sarb, 0);
 	}
@@ -616,7 +616,7 @@ static void usbatm_tx_process(unsigned l
 			struct atm_vcc *vcc = UDSL_SKB(skb)->atm.vcc;
 
 			usbatm_pop(vcc, skb);
-			atomic_inc(&vcc->stats->tx);
+			atomic_inc_unchecked(&vcc->stats->tx);
 
 			skb = skb_dequeue(&instance->sndqueue);
 		}
@@ -775,11 +775,11 @@ static int usbatm_atm_proc_read(struct a
 	if (!left--)
 		return sprintf(page,
 			       "AAL5: tx %d ( %d err ), rx %d ( %d err, %d drop )\n",
-			       atomic_read(&atm_dev->stats.aal5.tx),
-			       atomic_read(&atm_dev->stats.aal5.tx_err),
-			       atomic_read(&atm_dev->stats.aal5.rx),
-			       atomic_read(&atm_dev->stats.aal5.rx_err),
-			       atomic_read(&atm_dev->stats.aal5.rx_drop));
+			       atomic_read_unchecked(&atm_dev->stats.aal5.tx),
+			       atomic_read_unchecked(&atm_dev->stats.aal5.tx_err),
+			       atomic_read_unchecked(&atm_dev->stats.aal5.rx),
+			       atomic_read_unchecked(&atm_dev->stats.aal5.rx_err),
+			       atomic_read_unchecked(&atm_dev->stats.aal5.rx_drop));
 
 	if (!left--) {
 		if (instance->disconnected)
diff -urNp linux-2.6.32.24/drivers/usb/class/cdc-acm.c linux-2.6.32.24/drivers/usb/class/cdc-acm.c
--- linux-2.6.32.24/drivers/usb/class/cdc-acm.c	2010-09-20 17:26:42.000000000 -0400
+++ linux-2.6.32.24/drivers/usb/class/cdc-acm.c	2010-09-20 17:32:02.000000000 -0400
@@ -1618,7 +1618,7 @@ static struct usb_device_id acm_ids[] = 
 	{ USB_INTERFACE_INFO(USB_CLASS_COMM, USB_CDC_SUBCLASS_ACM,
 		USB_CDC_ACM_PROTO_AT_CDMA) },
 
-	{ }
+	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
 };
 
 MODULE_DEVICE_TABLE(usb, acm_ids);
diff -urNp linux-2.6.32.24/drivers/usb/class/cdc-wdm.c linux-2.6.32.24/drivers/usb/class/cdc-wdm.c
--- linux-2.6.32.24/drivers/usb/class/cdc-wdm.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/usb/class/cdc-wdm.c	2010-09-04 15:54:52.000000000 -0400
@@ -314,7 +314,7 @@ static ssize_t wdm_write
 	if (r < 0)
 		goto outnp;
 
-	if (!file->f_flags && O_NONBLOCK)
+	if (!(file->f_flags & O_NONBLOCK))
 		r = wait_event_interruptible(desc->wait, !test_bit(WDM_IN_USE,
 								&desc->flags));
 	else
diff -urNp linux-2.6.32.24/drivers/usb/class/usblp.c linux-2.6.32.24/drivers/usb/class/usblp.c
--- linux-2.6.32.24/drivers/usb/class/usblp.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/usb/class/usblp.c	2010-09-04 15:54:52.000000000 -0400
@@ -228,7 +228,7 @@ static const struct quirk_printer_struct
 	{ 0x0482, 0x0010, USBLP_QUIRK_BIDIR }, /* Kyocera Mita FS 820, by zut <kernel@zut.de> */
 	{ 0x04f9, 0x000d, USBLP_QUIRK_BIDIR }, /* Brother Industries, Ltd HL-1440 Laser Printer */
 	{ 0x04b8, 0x0202, USBLP_QUIRK_BAD_CLASS }, /* Seiko Epson Receipt Printer M129C */
-	{ 0, 0 }
+	{ 0, 0, 0 }
 };
 
 static int usblp_wwait(struct usblp *usblp, int nonblock);
@@ -1412,7 +1412,7 @@ static struct usb_device_id usblp_ids []
 	{ USB_INTERFACE_INFO(7, 1, 2) },
 	{ USB_INTERFACE_INFO(7, 1, 3) },
 	{ USB_DEVICE(0x04b8, 0x0202) },	/* Seiko Epson Receipt Printer M129C */
-	{ }						/* Terminating entry */
+	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }		/* Terminating entry */
 };
 
 MODULE_DEVICE_TABLE (usb, usblp_ids);
diff -urNp linux-2.6.32.24/drivers/usb/core/hcd.c linux-2.6.32.24/drivers/usb/core/hcd.c
--- linux-2.6.32.24/drivers/usb/core/hcd.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/usb/core/hcd.c	2010-09-04 15:54:52.000000000 -0400
@@ -2216,7 +2216,7 @@ EXPORT_SYMBOL_GPL(usb_hcd_platform_shutd
 
 #if defined(CONFIG_USB_MON) || defined(CONFIG_USB_MON_MODULE)
 
-struct usb_mon_operations *mon_ops;
+const struct usb_mon_operations *mon_ops;
 
 /*
  * The registration is unlocked.
@@ -2226,7 +2226,7 @@ struct usb_mon_operations *mon_ops;
  * symbols from usbcore, usbcore gets referenced and cannot be unloaded first.
  */
  
-int usb_mon_register (struct usb_mon_operations *ops)
+int usb_mon_register (const struct usb_mon_operations *ops)
 {
 
 	if (mon_ops)
